Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 933282 - app-arch/xz-utils-5.6.2 and previous version fails to build with sys-devel/gcc:13 but builds with sys-devel/gcc:11 (../../src/liblzma/.libs/liblzma.so: undefined reference to `__pthread_cond_timedwait64')
Summary: app-arch/xz-utils-5.6.2 and previous version fails to build with sys-devel/gc...
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo's Team for Core System packages
URL:
Whiteboard:
Keywords:
: 933528 (view as bug list)
Depends on:
Blocks:
 
Reported: 2024-05-31 21:10 UTC by Andreas
Modified: 2024-06-09 09:44 UTC (History)
6 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
dev-qt/qtcore-5.15.14 build log (build.log.xz,22.00 KB, application/x-xz)
2024-05-31 21:15 UTC, Andreas
Details
xz-utils build log (build.log,264.56 KB, text/x-log)
2024-05-31 21:35 UTC, Andreas
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Andreas 2024-05-31 21:10:39 UTC
app-arch/xz-utils-5.6.2 and previous version
Fails to build with gcc:13 but builds with gcc:11

https://pastebin.com/njhy11xz
build log 

https://pastebin.com/GARXixCr
emerge --info

dev-qt/qtcore-5.15.14
builds with gcc:11
please find the build.log attached.

net-p2p/transmission-4.0.6 and ANY other version of it does NOT build with any gcc,but it was finally built with clang:18

It must be something else.
Plz forward it to whomever appropriate.

Thanks a lot
Andreas
Comment 1 Andreas 2024-05-31 21:15:28 UTC
Created attachment 894759 [details]
dev-qt/qtcore-5.15.14 build log
Comment 2 Greg Kubaryk 2024-05-31 21:20:19 UTC
We need emerge --info as a comment and build.log attached (but it seems you already did the second part); pastebin.com links are no good.
Comment 3 Greg Kubaryk 2024-05-31 21:21:12 UTC
And by already did the second part, I meant that you uploaded a build.log for the incorrect package, so we still need that too. :)
Comment 4 Andreas 2024-05-31 21:35:13 UTC
Created attachment 894760 [details]
xz-utils build log
Comment 5 Andreas 2024-05-31 21:36:36 UTC
Portage 3.0.64 (python 3.11.9-final-0, default/linux/amd64/17.1/desktop, gcc-13, glibc-2.39-r7, 6.1.67-gentoo x86_64)
=================================================================
System uname: Linux-6.1.67-gentoo-x86_64-Intel-R-_Core-TM-_i7-4710HQ_CPU_@_2.50GHz-with-glibc2.39
KiB Mem:    16268848 total,   9138312 free
KiB Swap:   16777212 total,  16777212 free
Timestamp of repository gentoo: Fri, 31 May 2024 15:15:00 +0000
Head commit of repository gentoo: 44d137b171ab419fd073f3496cb03d5eccd1e6e0
Head commit of repository gentoo-zh: 179380aa434e9bdeee422c2e823de587d706c843

sh bash 5.2_p26-r3
ld GNU ld (Gentoo 2.42 p3) 2.42.0
app-misc/pax-utils:        1.3.7::gentoo
app-shells/bash:           5.2_p26-r3::gentoo
dev-build/autoconf:        2.72-r1::gentoo
dev-build/automake:        1.16.5-r2::gentoo
dev-build/cmake:           3.29.3::gentoo
dev-build/libtool:         2.4.7-r4::gentoo
dev-build/make:            4.4.1-r1::gentoo
dev-build/meson:           1.4.0-r1::gentoo
dev-java/java-config:      2.3.3-r1::gentoo
dev-lang/perl:             5.38.2-r6::gentoo
dev-lang/python:           3.11.9-r1::gentoo, 3.12.3-r1::gentoo, 3.13.0_beta1_p3::gentoo
dev-lang/rust-bin:         1.77.1::gentoo
sys-apps/baselayout:       2.15::gentoo
sys-apps/openrc:           0.54::gentoo
sys-apps/sandbox:          2.38::gentoo
sys-devel/binutils:        2.42-r1::gentoo
sys-devel/binutils-config: 5.5::gentoo
sys-devel/clang:           18.1.6::gentoo
sys-devel/gcc:             11.3.0::gentoo, 13.2.1_p20230826::gentoo
sys-devel/gcc-config:      2.11::gentoo
sys-devel/lld:             18.1.6::gentoo
sys-devel/llvm:            18.1.6::gentoo
sys-kernel/linux-headers:  6.9::gentoo (virtual/os-headers)
sys-libs/glibc:            2.39-r7::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.europe.gentoo.org/gentoo-portage
    priority: -1000
    volatile: False
    sync-rsync-extra-opts: 
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-metamanifest: yes

gentoo-zh
    location: /var/db/repos/gentoo-zh
    sync-type: git
    sync-uri: https://github.com/microcai/gentoo-zh
    masters: gentoo
    volatile: False

localrepo
    location: /var/db/repos/localrepo
    masters: gentoo
    volatile: False

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/easy-rsa /usr/share/gnupg/qualified.txt /var/bind"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php8.1/ext-active/ /etc/php/cgi-php8.1/ext-active/ /etc/php/cli-php8.1/ext-active/ /etc/php/fpm-php8.1/ext-active/ /etc/php/phpdbg-php8.1/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -O2 -pipe"
DISTDIR="/var/cache/distfiles"
EMERGE_DEFAULT_OPTS="--quiet-build=y"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GDK_PIXBUF_MODULE_FILE GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR XDG_STATE_HOME"
FCFLAGS="-march=native -O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs binpkg-multi-instance buildpkg-live config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync merge-wait multilib-strict network-sandbox news parallel-fetch pid-sandbox pkgdir-index-trusted preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-march=native -O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LEX="flex"
MAKEOPTS="-j4"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
SHELL="/bin/bash"
USE="X a52 aac acl acpi alsa amd64 bluetooth branding bzip2 cairo cdda cdr cli crypt cups dbus dri dts dvd dvdr elogind encode exif flac fortran gdbm gif gles2 gpm gtk gui iconv ipv6 jpeg lcms libnotify libtirpc mad matroska mng mp3 mp4 mpeg multilib ncurses nls ogg opengl openmp openssl pam pango pcre pdf pipewire png policykit ppds pulseaudio readline screencast sdl seccomp sound spell split-usr ssl startup-notification svg test-rust theora tiff truetype udev udisks unicode upower usb vaapi vdpau vorbis vpx vulkan wayland wxwidgets x264 xattr xcb xfce xft xml xv xvid xwayland zlib" ABI_X86="64" ADA_TARGET="gcc_12" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_anon authn_dbm authn_file authz_dbm authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir env expires ext_filter file_cache filter headers include info log_config logio mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" APACHE2_MPMS="event" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2 aes avx avx2 f16c fma3 pclmul popcnt rdrand sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 ntrip navcom oceanserver oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 tsip tripmate tnt ublox" GRUB_PLATFORMS="efi-64" INPUT_DEVICES="libinput synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz glk hd44780 lb216 lcdm001 mtxorb text" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php8-1" POSTGRES_TARGETS="postgres15" PYTHON_SINGLE_TARGET="python3_11" PYTHON_TARGETS="python3_11" RUBY_TARGETS="ruby31 ruby32" VIDEO_CARDS="intel nvidia nouveau" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipp2p iface geoip fuzzy condition tarpit sysrq proto logmark ipmark dhcpmac delude chaos account"
Unset:  ADDR2LINE, AR, ARFLAGS, AS, ASFLAGS, CC, CCLD, CONFIG_SHELL, CPP, CPPFLAGS, CTARGET, CXX, CXXFILT, ELFEDIT, EXTRA_ECONF, F77FLAGS, FC, GCOV, GPROF, INSTALL_MASK, LC_ALL, LD, LFLAGS, LIBTOOL, LINGUAS, MAKE, MAKEFLAGS, NM, OBJCOPY, OBJDUMP, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, PYTHONPATH, RANLIB, READELF, RUSTFLAGS, SIZE, STRINGS, STRIP, YACC, YFLAGS



[ebuild   R    ] app-arch/xz-utils-5.6.2::gentoo  USE="extra-filters nls -doc -pgo -static-libs -verify-sig" ABI_X86="(64) -32 (-x32)" 0 KiB
[ebuild   R    ] dev-qt/qtcore-5.15.14:5/5.15.14::gentoo  USE="-debug -icu -old-kernel -test" 0 KiB
[ebuild   R    ] net-p2p/transmission-4.0.6::gentoo  USE="cli gtk nls -appindicator -debug -mbedtls -qt5 -qt6 -systemd -test" 0 KiB
Comment 6 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-05-31 21:37:21 UTC
Please run the following and share its output in full: echo '#include <pthread.h>' | cpp -dM - | grep USE_TIME.

Is there anything interesting about your system?
Comment 7 Andreas 2024-05-31 21:43:57 UTC
echo '#include <pthread.h>' | cpp -dM - | grep USE_TIME
#define __USE_TIME_BITS64 1


No there is nothing special about my system other than being testing.
Comment 8 Andreas 2024-05-31 22:01:14 UTC
This is any reference of pthread i could find.

eqb pthread.h
 * Searching for pthread.h ... 
sys-devel/gcc-13.2.1_p20230826 (/usr/lib/gcc/x86_64-pc-linux-gnu/13/include-fixed/pthread.h)
sys-libs/glibc-2.39-r7 (/usr/include/pthread.h)

Should I maybe update gcc:13?
Comment 9 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-05-31 22:39:38 UTC
My guess is that this (somehow) broke with sys-libs/glibc-2.39-r7 which contains https://sourceware.org/git/?p=glibc.git;a=commit;h=dd535f4f19ef2b5c367a362af445ecadcf45401e.

What I don't yet get is why, or why I can't reproduce it.
Comment 10 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-05-31 22:41:03 UTC
(In reply to Andreas from comment #8)
> This is any reference of pthread i could find.
> 
> eqb pthread.h
>  * Searching for pthread.h ... 
> sys-devel/gcc-13.2.1_p20230826
> (/usr/lib/gcc/x86_64-pc-linux-gnu/13/include-fixed/pthread.h)
> sys-libs/glibc-2.39-r7 (/usr/include/pthread.h)
> 
> Should I maybe update gcc:13?

AH, it might make sense if it's caused by fixincludes!!!! Can you try emerge -v1 sys-devel/gcc:13?

(Also, why do you have such an old GCC 13 if you're on ~arch?)
Comment 11 José de Paula Rodrigues 2024-06-03 00:30:31 UTC
I was having this issue when building net-dns/c-ares (undefined reference to `__pthread_cond_timedwait64') as part of upgrading the profile from 17.0 to 23.0. Rebuilding gcc:13 solved the issue (don't forget bug #915389 if you are on amd64 with an Intel *-lake CPU).
Comment 12 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-06-07 08:59:27 UTC
ago mentioned he hit this the other day to me but I've not had a chance to look yet.

See also https://inbox.sourceware.org/libc-stable/e3ca5f81-b650-4803-92ad-315724a259db@reillybrogan.com/.
Comment 13 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-06-07 09:07:06 UTC
Ah, ago clarified it was upgrading an old chroot. So, the fixincludes theory stands.

We only had fixincludes enabled for a period for new glibc compatibility (been off for years, was on for a bit, now off again).
Comment 14 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-06-09 09:42:27 UTC
*** Bug 933528 has been marked as a duplicate of this bug. ***
Comment 15 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2024-06-09 09:44:22 UTC
I'm somewhat stuck on what the best course of action here is (had another dupe).

I suppose someone (probably me) needs to reproduce this with a fixincludes gcc to prove it's the fault of it. But even then, how do we actually fix this easily on our end? News item and ask people to rebuild? News item asking people to delete the pthreads.h header from the fixincs dir?

On the upstream side, if fixincludes is to blame, we should probably recommend removing/fixing the rule which causes pthreads.h to be mangled (I bet it's at least not relevant on modern Linux systems, so could be made more specific so it's not always applied).